
/*
** Copyright (C) 2004 Herbert Poetzl
**
** V0.01	test for syscall
**
*/

#define VERSION "V0.01"

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <signal.h>
#include <syscall.h>
#include <asm/unistd.h>
#include <unistd.h>
#include <sched.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/mount.h>
#include <sys/time.h>


 
#include "vswitch.h"


static	char	err_flag = 0;

static	char	opt_vserv = 0;

static	int	opt_loops = 100;

static	char *	cmd_name = NULL;


#define TOUS(x)     ((x)*1000*1000)

#define OPTIONS "+hn:XV"

int	main(int argc, char *argv[])
{
        struct timeval start_time, end_time;
        extern int optind;
        extern char *optarg;
        char c, errflg = 0;
	int r, i;
	long delta;


        cmd_name = argv[0];
        while ((c = getopt(argc, argv, OPTIONS)) != EOF) {
            switch (c) {
            case 'h':
                fprintf(stderr,
                    "This is %s " VERSION "\n"
                    "options are:\n"
                    "-h        print this help message\n"
                    "-n <num>  number of loops\n"
                    "-X        test vserver syscall\n"
                    "--        end of options\n"
                    ,cmd_name);
                exit(0);
                break;
            case 'n':
                opt_loops = atoi(optarg);
                break;
            case 'X':
                opt_vserv = 1;
                break;
            case '?':
            default:
                errflg++;
                break;
            }
        }
        if (errflg) {
            fprintf(stderr, 
                "Usage: %s -[" OPTIONS "]\n"
                "%s -h for help.\n",
                cmd_name, cmd_name);
            exit(2);
        }


        gettimeofday(&start_time, NULL);

	for (i=0; i < opt_loops; i++) {
	     r = getpgid(1);
	}

	gettimeofday(&end_time, NULL);
	delta = TOUS(end_time.tv_sec - start_time.tv_sec)
            + (end_time.tv_usec - start_time.tv_usec);

	printf(" %7lu us\t %5lu\n", delta, delta/opt_loops);
	exit((err_flag)?1:0);
}

